unit U_main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Serial, StdCtrls;

type
  TForm1 = class(TForm)
    editNumber: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    editPort: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    editTx: TEdit;
    editRx: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Serial1: TSerial;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Serial1RxData(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
begin
    { Open the serial port }
    Serial1.Port := StrToInt(EditPort.Text);
    Serial1.Active := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    { Close the serial port }
    Serial1.Active := False;
end;

procedure TForm1.Serial1RxData(Sender: TObject);
var
    c : Char ;
begin
    { Get characters into the rx edit box
      but skip LF  and translate CR to | }

    while Serial1.RxWaiting > 0 do
    begin
        Serial1.ReadChar(c);
        if c<>#10 then
        begin
           if c<>#13 then
             EditRx.Text := EditRx.Text+c
           else
             EditRx.Text := EditRx.Text+'|'
        end
    end
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if Serial1.Active then
    begin
        { Send attention, CR, reset command }
        Serial1.WriteString ('+++'+Chr(13)+'ATZ'+Chr(13));
        editTx.Text := '+++|ATZ|' ;
        editRx.Text := ''
    end
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
    if Serial1.Active then
    begin
        { Send dial string }
        Serial1.WriteString ('ATDT'+editNumber.Text+Chr(13));
        editTx.Text := 'ATDT'+editNumber.Text+'|' ;
        editRx.Text := ''
    end
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
    if Serial1.Active then
    begin
        { Send attention, hangup }
        Serial1.WriteString ('+++ATH'+Chr(13));
        editTx.Text := '+++ATH|' ;
        editRx.Text := ''
    end
end;

end.
